| Disk ARchive 2.5.10 Full featured and portable backup and archiving tool

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
libdar::null_file Class Reference
Private

the null_file class implements the /dev/null behavior More...

`#include <null_file.hpp>`

Inherits libdar::generic_file, and libdar::thread_cancellation.

## Public Member Functions
| null_file (gf_mode m)
bool | skippable (skippability direction, const infinint &amount)
bool | skip (const infinint &pos)
bool | skip_to_eof ()
| skip to the end of file
bool | skip_relative (signed int x)
infinint | get_position () const
| get the current read/write position
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
virtual | ~generic_file () throw (Ebug)
| virtual destructor, this let inherited destructor to be called even from a generic_file pointer to an inherited class
void | terminate () const
| destructor-like call, except that it is allowed to throw exceptions
const generic_file & | operator= (const generic_file &ref)
| assignment operator
gf_mode | get_mode () const
| retreive the openning mode for this object
virtual void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
U_I | read (char *a, U_I size)
| read data from the generic_file More...
void | write (const char *a, U_I size)
| write data to the generic_file More...
void | write (const std::string &arg)
| write a string to the generic_file More...
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual bool | skip_relative (S_I x)=0
| skip relatively to the current position
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data More...
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument More...
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data More...
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset More...
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::on_pool
void * | operator new (size_t n_byte)
void * | operator new (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new[] (size_t n_byte)
void * | operator new[] (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new (size_t n_byte, memory_pool *p)
void * | operator new[] (size_t n_byte, memory_pool *p)
void | operator delete (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated object
void | operator delete[] (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated objects
void | operator delete (void *ptr)
| this is the usual delete operator, modified to handle allocated objects allocated on a memory pool or not
void | operator delete[] (void *ptr)
| this is the usual delete[] operator, modified to handle allocated objects allocated on a memory pool or not
Public Member Functions inherited from libdar::thread_cancellation
| thread_cancellation ()
| the constructor
virtual | ~thread_cancellation () throw (Ebug)
| the destructor
void | check_self_cancellation () const
| Checkpoint test : whether the current libdar call must abort or not. More...
void | block_delayed_cancellation (bool mode)

## Protected Member Functions
void | inherited_read_ahead (const infinint &amount)
U_I | inherited_read (char *a, U_I size)
| implementation of read() operation More...
void | inherited_write (const char *a, U_I size)
| implementation of the write() operation More...
void | inherited_sync_write ()
| write down any pending data More...
void | inherited_flush_read ()
void | inherited_terminate ()
| destructor-like call, except that it is allowed to throw exceptions More...
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const
Protected Member Functions inherited from libdar::on_pool
memory_pool * | get_pool () const
template<class T >
void | meta_new (T *&ptr, size_t num)
template<class T >
void | meta_delete (T *ptr)

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward, skip_forward }
Static Public Member Functions inherited from libdar::thread_cancellation
static U_I | count ()
| method for debugging/control purposes

## Detailed Description

the null_file class implements the /dev/null behavior

this is a generic_file implementation that emulate the comportment of the /dev/null special file. all that is writen to is lost, and nothing can be read from it (empty file). This is a completed implementation all call are consistent.

Definition at line 50 of file null_file.hpp.

## Member Function Documentation

void libdar::null_file::inherited_flush_read | ( |  | ) |
| inline protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 79 of file null_file.hpp.

U_I libdar::null_file::inherited_read | ( | char * | a,
|  | U_I | size
| ) |  |
| inline protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

Definition at line 63 of file null_file.hpp.

References libdar::thread_cancellation::check_self_cancellation().

void libdar::null_file::inherited_read_ahead | ( | const infinint & | amount | ) |
| inline protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 61 of file null_file.hpp.

void libdar::null_file::inherited_sync_write | ( |  | ) |
| inline protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 78 of file null_file.hpp.

void libdar::null_file::inherited_terminate | ( |  | ) |
| inline protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

Definition at line 80 of file null_file.hpp.

void libdar::null_file::inherited_write | ( | const char * | a,
|  | U_I | size
| ) |  |
| inline protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

Definition at line 71 of file null_file.hpp.

References libdar::thread_cancellation::check_self_cancellation().

bool libdar::null_file::skip | ( | const infinint & | pos | ) |
| inline virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

Definition at line 55 of file null_file.hpp.

bool libdar::null_file::skippable | ( | skippability | direction,
|  | const infinint & | amount
| ) |  |
| inline virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 54 of file null_file.hpp.

The documentation for this class was generated from the following file:

- null_file.hpp